#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MOD=1e9+7;
const int MAXVAL=1e6+55;

int q;
int x,y;
int lp[MAXVAL];
int fact[MAXVAL];
int invFact[MAXVAL];

void sieve()
{
    lp[1]=1;
    for(int i=2; i<MAXVAL; i++)
    {
        if(lp[i]) continue;
        lp[i]=i;
        if((long long)i*i>=MAXVAL) continue;
        for(int j=i*i; j<MAXVAL; j+=i)
        {
            if(!lp[j]) lp[j]=i;
        }
    }
}

int fastPow(int a,int pwr)
{
    long long ret=1;
    while(pwr>0)
    {
        if(pwr%2) ret=ret*a%MOD;
        a=(long long) a*a%MOD;
        pwr/=2;
    }
    return ret;
}

void precomp()
{
    fact[0]=invFact[0]=1;
    for(int i=1; i<MAXVAL; i++)
    {
        fact[i]=(long long)fact[i-1]*i%MOD;
    }
    invFact[MAXVAL-1]=fastPow(fact[MAXVAL-1],MOD-2);
    for(int i=MAXVAL-2;i>0;i--)
    {
        invFact[i]=(long long)invFact[i+1]*(i+1)%MOD;
    }
}

int comb(int n,int k)
{
    return (long long)fact[n]*invFact[n-k]%MOD*invFact[k]%MOD;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    sieve();
    precomp();

    cin>>q;
    while(q--)
    {
        cin>>x>>y;
        long long ans=1;
        while(x>1)
        {
            int d=lp[x];
            int cnt=0;
            while(d==lp[x])
            {
                cnt++;
                x/=d;
            }
            ans=ans*comb(y+cnt-1,cnt)%MOD;
        }
        ans=ans*fastPow(2,y-1)%MOD;
        cout<<ans<<endl;
    }

    return 0;
}
