/**
https://olympiads.ru/zaoch/2021-22/zaoch/long_editorial.pdf
*/

#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN=2e5+5;
const int MOD=1e9+7;

int n;
vector<int> adj[MAXN];
int par[MAXN];
int a[MAXN];
int sum=0;
int negCnt=0;
int inv[MAXN];
int comb[MAXN];
int fact[MAXN];
int s=0;

void precomp()
{
    fact[0]=1;
    for(int i=1; i<=n; i++) fact[i]=(long long)fact[i-1]*i%MOD;

    inv[1]=1;
    for(int i=2; i<=n; i++)
    {
        inv[i]=(long long)MOD-((long long)MOD/i)*inv[MOD%i]%MOD;
    }

    comb[negCnt]=1;
    for(int i=negCnt+1; i<=n; i++)
    {
        comb[i]=(long long)comb[i-1]*i%MOD*inv[i-negCnt]%MOD;
    }
}

void dfs(int v,int depth)
{
    if(n-depth<negCnt) return;
    s=(s+comb[n-depth])%MOD;
    for(int i=0; i<adj[v].size(); i++)
    {
        if(adj[v][i]==par[v]) continue;
        dfs(adj[v][i], depth+1);
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin>>n;
    for(int i=2; i<=n; i++)
    {
        cin>>par[i];
        adj[par[i]].push_back(i);
        adj[i].push_back(par[i]);
    }
    for(int i=1; i<=n; i++)
    {
        cin>>a[i];
        if(a[i]>=0) sum=(sum+a[i])%MOD;
        else negCnt++;
    }

    precomp();

    if(negCnt==0)
    {
        cout<<(long long) sum*fact[n]%MOD<<endl;
        return 0;
    }

    dfs(1,1);

    long long ans=(long long) s*sum%MOD;
    ans=ans*fact[negCnt]%MOD;
    ans=ans*fact[n-negCnt-1]%MOD;

    cout<<ans<<endl;

    return 0;
}
