#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXVAL=1e6+5;
const int MOD=1e9+7;

int l,r;
int inv[MAXVAL]; // inv[x] =    x   MOD
int lp[MAXVAL];
int prPow[MAXVAL]; //              divCnt; prPow[x] = ,   x      (x  )
int divCnt[MAXVAL]; // divCnt[x] =    x 
int pref[MAXVAL];

void sieve()
{
    lp[1]=1;
    for(int i=2; i<MAXVAL; i++)
    {
        if(lp[i]) continue;
        lp[i]=i;
        if((long long)i*i>=MAXVAL) continue;
        for(int j=i*i; j<MAXVAL; j+=i)
        {
            if(!lp[j]) lp[j]=i;
        }
    }
}

int fastPow(int a,int pwr)
{
    long long ret=1;
    while(pwr>0)
    {
        if(pwr&1) ret=ret*a%MOD;
        a=(long long)a*a%MOD;
        pwr/=2;
    }
    return ret;
}

void precomp()
{
    // ,  -        n!   n-1 (?),            MAXVAL
    for(int i=1; i<MAXVAL; i++)
    {
        inv[i]=fastPow(i,MOD-2);
    }

    //      divCnt,        :
    //  x=(p1^a1)*(p2^a2)*...*(pk^ak)     x,     x  (a1+1)*(a2+1)*...*(ak+1)
    divCnt[1]=1;
    for(int i=2; i<MAXVAL; i++) //     i      divCnt[i]
    {
        int a=i;
        long long curr=divCnt[i-1]; //    divCnt[i]    divCnt[i-1],  i!=(i-1)!*i , ..      i
                                    //           ,  ,         
                                    //    ,     
        while(a>1)
        {
            int d=lp[a];
            curr=(curr*inv[prPow[d]+1])%MOD; // ""      ,    
            while(d==lp[a])
            {
                prPow[d]++;
                a/=d;
            }
            curr=(curr*(prPow[d]+1))%MOD; //   ""    
        }
        divCnt[i]=curr;
    }
    //   5!   (2^3)*(3^1)*(5^1)      (3+1)*(1+1)*(1+1)=16
    //     6!    (2^4)*(3^2)*(5^1),       (     6)  ,
    //              (4+1)*(2+1)*(1+1)=30

    for(int i=1; i<MAXVAL; i++)
    {
        pref[i]=pref[i-1]+divCnt[i];
        if(pref[i]>MOD) pref[i]-=MOD;
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    sieve();
    precomp();

    int t;
    cin>>t;
    while(t--)
    {
        cin>>l>>r;
        cout<<(pref[r]-pref[l-1]+MOD)%MOD<<endl;
    }

    return 0;
}
